# Proložení bodů přímkou metodou nejmenších čtverců
# Jan Kybic, 2017

import numpy as np              # Numeric Python
import matplotlib.pyplot as plt # pro zobrazování a grafy


x=np.array([10,20,30,40,50])
y=np.array([17.1,21.9,24.5,29.5,35.8])

plt.plot(x,y,'ro')
plt.xlabel('x')
plt.ylabel('y')
plt.title('Measured data')
plt.axis((0,60,10,40))
plt.savefig('figs/namerena_data.pdf')
# plt.show()

# najdeme lineární aproximaci interpolaci metodou nejmenších čtverců
n=len(x)
sx=np.sum(x)
sy=np.sum(y)
sxy=np.dot(x,y)
sxx=np.dot(x,x)
A=np.array([[sxx,sx],[sx,n]])
r=np.array([sxy,sy])
theta=np.linalg.solve(A,r) # obsahuje A,B
print("theta=",theta)
# zkusíme interpolovat
t=np.arange(0,60,0.1)
z=t*theta[0]+theta[1]
plt.plot(t,z,'b-')
plt.legend(['naměřená data','aproximace'],loc='upper left')
plt.savefig('figs/aproximace.pdf')
plt.show()
